--   
IF EXISTS (SELECT name FROM master.dbo.sysdatabases WHERE name='FormAuthUsers')
	DROP DATABASE [FormAuthUsers]

--   'FormAuthUsers'
CREATE DATABASE FormAuthUsers
GO
USE FormAuthUsers
GO

--  'Users'
CREATE TABLE [Users] (
	[ID] [int] IDENTITY (1, 1) NOT NULL,
	[UserName] [nvarchar] (50),
	[Password] [nvarchar] (50),
	
	CONSTRAINT [PK_Users] PRIMARY KEY
	([ID]) ON [PRIMARY]
) ON [PRIMARY]
GO
--  'Roles'
CREATE TABLE [Roles] (
	[ID] [int] IDENTITY (1,1) NOT NULL,
	[Role] [nvarchar] (50)
	
	CONSTRAINT [PK_Roles] PRIMARY KEY
	([ID]) ON [PRIMARY]
) ON [PRIMARY]
GO
--  'UserRole'
CREATE TABLE [UserRole] (
	[ID] [int] IDENTITY (1,1) NOT NULL,
	[UserID] [int] NOT NULL,
	[RoleID] [int] NOT NULL

	CONSTRAINT [PK_UserRole] PRIMARY KEY
	([ID]) ON [PRIMARY]
) ON [PRIMARY]

GO

--  'Users'
INSERT INTO Users (UserName, Password)
VALUES('John', 'one')
GO
INSERT INTO Users (UserName, Password)
VALUES('Mike', 'two')
GO
INSERT INTO Users (UserName, Password)
VALUES('Bill', 'three')
GO
--   'Roles'
INSERT INTO Roles(Role)
VALUES('Administrators')
GO
INSERT INTO Roles(Role)
VALUES('Users')
GO
--  'UserRole'
INSERT INTO UserRole(UserID, RoleID)
VALUES (1, 1)
GO
INSERT INTO UserRole(UserID, RoleID)
VALUES (2, 1)
GO
INSERT INTO UserRole(UserID, RoleID)
VALUES (3, 2)

GO

--  'FindUser'
CREATE PROCEDURE FindUser
	@Name nvarchar(50),
	@Password nvarchar(50)
AS
	SELECT COUNT(ID) FROM Users
	WHERE UserName = @Name AND Password = @Password

GO

--  'FindRoles'
CREATE PROCEDURE FindRoles
	@UserName nvarchar (50)
AS
	SELECT R.Role FROM Users U, Roles R, UserRole UR
	WHERE U.UserName = @UserName AND UR.UserID = U.ID AND UR.RoleID = R.ID
GO